<?php

/**
 */
class Setup extends Screen implements UserInputHandler
{
    const ID = 'Setup_ID';

    function handle_user_input(&$user_input, &$plugin_cookies) {}

    /**
     *
     * @return type 
     */
    function get_handler_id()
    {
        return self::ID;
    }

    
    /**
     *
     * @param type $arg
     * @return type 
     */
    function input(&$arg)
    {
        if(isset($arg->control_id)) 
        {
            switch ($arg->control_id)
            {
                case 'Setup->buffer_ms':
                    
                    Cookie::set('buffer_ms', $arg->{$arg->control_id});
                    break;
                case 'Setup->quality':
                    
                    Cookie::set('video_quality', $arg->{$arg->control_id});
                    break;
                case 'Setup->access_for_upgrade':
                    
                    Cookie::set('access_for_upgrade', $arg->{$arg->control_id});
                    break;
            }
        }
        
        return;
    }
    
    /**
     *
     * @return type 
     */
    function settings()
    {
        $defs = $this->do_get_control_defs();
        $folder_view = array
            (
            PluginControlsFolderView::defs => $defs,
            PluginControlsFolderView::initial_sel_ndx => -1,
        );
        return array
            (
            PluginFolderView::multiple_views_supported => false,
            PluginFolderView::archive => null,
            PluginFolderView::view_kind => PLUGIN_FOLDER_VIEW_CONTROLS,
            PluginFolderView::data => $folder_view,
        );
    }

    /**
     *
     * @param type $plugin_cookies
     * @return array 
     */
    public function do_get_control_defs()
    {
        $defs = array();

        ControlFactory::add_label($defs, 'Plugin App Box ' . TangoDunePlugin::CURRENT_PLUGIN_VERSION_TITLE . ' [' . TangoDunePlugin::CURRENT_PLUGIN_VERSION_DATE . ']', '');
        
        $video_quality = Cookie::get('access_for_upgrade', 0);
        
        $show_ops = array();
        $show_ops['0'] = 'только стабильные версии';
        $show_ops['1'] = 'стабильные и beta версии';
        
        ControlFactory::add_combobox($defs, $this, null, 
                'Setup->access_for_upgrade', 'Загружать обновления:', $video_quality, $show_ops, 0, true, false);
        
        return $defs;
    }

}

?>
