<?php

class DuneLists
{
    /**
     *
     * @param type $items
     * @param type $actions 
     */
    static function build_category_img_list($items, $actions)
    {
        $regularItems = array
            (
            PluginRegularFolderRange::total => count($items),
            PluginRegularFolderRange::count => count($items),
            PluginRegularFolderRange::more_items_available => false,
            PluginRegularFolderRange::from_ndx => 0,
            PluginRegularFolderRange::items => $items,
        );

        $setup_action = array(
                        GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                        GuiAction::data => array(
                            PluginOpenFolderActionData::media_url => 'Setup->settings',
                        ),
                        GuiAction::caption => "Настройки"
                    );

        return array
            (
            PluginFolderView::view_kind => PLUGIN_FOLDER_VIEW_REGULAR,
            PluginFolderView::multiple_views_supported => true,
            PluginFolderView::data => array
                (
                PluginRegularFolderView::async_icon_loading => false,
                PluginRegularFolderView::initial_range => $regularItems,
                PluginRegularFolderView::view_params => array
                    (
                    ViewParams::num_cols => 5,
                    ViewParams::num_rows => 4,
                    ViewParams::paint_icon_selection_box => TRUE,
                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => Rise::$config->load('narkomsu.steklo_aai'), 
                    ViewParams::sandwich_cover => Rise::$config->load('narkomsu.steklo_png'), 
                    ViewParams::sandwich_width => 245,
                    ViewParams::sandwich_height => 140,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => true,
                ),
                PluginRegularFolderView::base_view_item_params => array
                    (
                    ViewItemParams::icon_path => 'missing://',
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_dx => 20,
                    ViewItemParams::icon_dy => -5,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                    ViewItemParams::item_caption_width => 1550
                ),
                PluginRegularFolderView::not_loaded_view_item_params => array(),
                PluginRegularFolderView::actions => array
                    (
                    GUI_EVENT_KEY_ENTER => array
                        (
                        GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                    ),
                    GUI_EVENT_KEY_B_GREEN => $setup_action
                )
            )
        );
    }

    /**
     *
     * @param type $items
     * @param type $actions 
     */
    static function build_category_text_list($items, $actions)
    {
        $regularItems = array
            (
            PluginRegularFolderRange::total => count($items),
            PluginRegularFolderRange::count => count($items),
            PluginRegularFolderRange::more_items_available => false,
            PluginRegularFolderRange::from_ndx => 0,
            PluginRegularFolderRange::items => $items,
        );

        $setup_action = array(
                        GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                        GuiAction::data => array(
                            PluginOpenFolderActionData::media_url => 'Setup->settings',
                        ),
                        GuiAction::caption => "Настройки"
                    );
        
        return array
            (
            PluginFolderView::view_kind => PLUGIN_FOLDER_VIEW_REGULAR,
            PluginFolderView::multiple_views_supported => true,
            PluginFolderView::data => array
                (
                PluginRegularFolderView::async_icon_loading => false,
                PluginRegularFolderView::initial_range => $regularItems,
                PluginRegularFolderView::view_params => array
                    (
                    ViewParams::num_cols => 1,
                    ViewParams::num_rows => 12,
                ),
                PluginRegularFolderView::base_view_item_params => array
                    (
                    ViewItemParams::icon_scale_factor => 0.75,
                    ViewItemParams::icon_sel_scale_factor => 1,
                    ViewItemParams::icon_path => 'missing://',
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL
                ),
                PluginRegularFolderView::not_loaded_view_item_params => array(),
                PluginRegularFolderView::actions => array
                    (
                    GUI_EVENT_KEY_ENTER => array
                    (
                        GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                    ),
                    GUI_EVENT_KEY_B_GREEN => $setup_action
                )
            )
        );
    }

    /**
     *
     * @param type $items
     * @param type $actions
     * @return type 
     */
    static function build_img_list($items, $actions)
    {
        return array
            (
            PluginFolderView::view_kind => PLUGIN_FOLDER_VIEW_REGULAR,
            PluginFolderView::multiple_views_supported => false,
            PluginFolderView::data => array
                (
                PluginRegularFolderView::async_icon_loading => false,
                PluginRegularFolderView::initial_range => array
                    (
                    PluginRegularFolderRange::total => count($items),
                    PluginRegularFolderRange::count => count($items),
                    PluginRegularFolderRange::more_items_available => false,
                    PluginRegularFolderRange::from_ndx => 0,
                    PluginRegularFolderRange::items => $items
                ),
                PluginRegularFolderView::view_params => array(
                    ViewParams::num_cols => 5,
                    ViewParams::num_rows => 2,
                    //ViewParams::paint_sandwich => true,
                    ViewParams::paint_details => true,
                    ViewParams::zoom_detailed_icon => true,
                    ViewParams::animation_enabled => true,
                    ViewParams::paint_item_info_in_details => true,
                    ViewParams::item_detailed_info_font_size => FONT_SIZE_NORMAL,
                    //ViewParams::item_detailed_info_rel_y => 590,

                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                    ViewParams::sandwich_width => 190,
                    ViewParams::sandwich_height => 290,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => true,
                ),
                PluginRegularFolderView::base_view_item_params => array(
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_paint_caption => true,
                    //ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai',
                    ViewItemParams::icon_path => 'plugin_file://icons/mov_unset.1.png',
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_width => 190,
                    ViewItemParams::icon_height => 290,
                    ViewItemParams::icon_sel_margin_top => 0,
                    ViewItemParams::icon_sel_scale_factor => 1.2,
                ),
                PluginRegularFolderView::not_loaded_view_item_params => array(
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::icon_width => 190,
                    ViewItemParams::icon_height => 290,
                    //ViewItemParams::icon_path => 'gui_skin://large_icons/movie.aai',
                    ViewItemParams::icon_path => 'plugin_file://icons/mov_unset.1.png',
                    ViewItemParams::item_paint_caption => false,
                    ViewItemParams::icon_keep_aspect_ratio => true,
                    ViewItemParams::icon_sel_margin_top => 0
                ),
                PluginRegularFolderView::actions => $actions
            )
        );
    }

    /**
     *
     * @param type $items
     * @param type $actions 
     */
    static function build_text_list_with_reloading($items, $actions)
    {
        return array
            (
            PluginFolderView::view_kind => PLUGIN_FOLDER_VIEW_REGULAR,
            PluginFolderView::multiple_views_supported => true,
            PluginFolderView::data => array
                (
                PluginRegularFolderView::async_icon_loading => TRUE,
                PluginRegularFolderView::initial_range => $items,
                PluginRegularFolderView::view_params => array
                    (
                    ViewParams::num_cols => 1,
                    ViewParams::num_rows => 12,
                    ViewParams::paint_details => TRUE,
                    ViewParams::paint_item_info_in_details => TRUE,
                    ViewParams::zoom_detailed_icon => TRUE,
                ),
                PluginRegularFolderView::base_view_item_params => array
                    (
                    ViewItemParams::icon_scale_factor => 0.75,
                    ViewItemParams::icon_sel_scale_factor => 1,
                    ViewItemParams::icon_path => 'missing://',
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                ),
                PluginRegularFolderView::not_loaded_view_item_params => array
                    (
                    PluginRegularFolderRange::total => 1,
                    PluginRegularFolderRange::count => 1,
                    PluginRegularFolderRange::more_items_available => true,
                    PluginRegularFolderRange::from_ndx => 0,
                    PluginRegularFolderRange::items => array
                        (
                        PluginRegularFolderItem::caption => 'Загрузка',
                        PluginRegularFolderItem::view_item_params => array
                            (
                            ViewItemParams::item_paint_icon => FALSE,
                            ViewItemParams::item_layout => HALIGN_LEFT,
                            ViewItemParams::icon_valign => VALIGN_CENTER,
                            ViewItemParams::item_paint_caption_within_icon => false,
                            ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                        ),
//                        PluginRegularFolderItem::media_url => get_class($obj) . '->index'
                    )
                ),
                PluginRegularFolderView::actions => $actions
            )
        );
    }

    /**
     *
     * @param type $items
     * @param type $actions
     * @return type 
     */
    static function build_img_with_details_list_with_reloading($items, $actions)
    {
        return array
            (
            PluginFolderView::view_kind => PLUGIN_FOLDER_VIEW_REGULAR,
            PluginFolderView::multiple_views_supported => true,
            PluginFolderView::data => array
                (
                PluginRegularFolderView::async_icon_loading => TRUE,
                PluginRegularFolderView::initial_range => $items,
                PluginRegularFolderView::view_params => array
                    (
                    ViewParams::num_cols => 5,
                    ViewParams::num_rows => 2,
                    ViewParams::paint_details => true,
                    ViewParams::zoom_detailed_icon => true,
                    ViewParams::animation_enabled => true,
                    ViewParams::paint_item_info_in_details => true,
                    ViewParams::item_detailed_info_font_size => FONT_SIZE_NORMAL,

                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                    ViewParams::sandwich_width => 190,
                    ViewParams::sandwich_height => 290,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => true,
                ),
                PluginRegularFolderView::base_view_item_params => array
                    (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_paint_caption => true,
                    ViewItemParams::icon_path => 'plugin_file://icons/mov_unset.1.png',
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_width => 190,
                    ViewItemParams::icon_height => 290,
                    ViewItemParams::icon_sel_margin_top => 0,
                    ViewItemParams::icon_sel_scale_factor => 1.2,
                ),
                PluginRegularFolderView::not_loaded_view_item_params => array
                    (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::icon_width => 190,
                    ViewItemParams::icon_height => 290,
                    ViewItemParams::icon_path => 'plugin_file://icons/mov_unset.1.png',
                    ViewItemParams::item_paint_caption => false,
                    ViewItemParams::icon_keep_aspect_ratio => true,
                    ViewItemParams::icon_sel_margin_top => 0
                ),
                PluginRegularFolderView::actions => $actions
            )
        );
    }
    
    
    /**
     *
     * @param type $items
     * @param type $actions
     * @return type 
     */
    static function build_img_list_with_reloading($items, $actions)
    {
        return array
            (
            PluginFolderView::view_kind => PLUGIN_FOLDER_VIEW_REGULAR,
            PluginFolderView::multiple_views_supported => true,
            PluginFolderView::data => array
                (
                PluginRegularFolderView::async_icon_loading => TRUE,
                PluginRegularFolderView::initial_range => $items,
                PluginRegularFolderView::view_params => array
                    (
                    ViewParams::num_cols => 5,
                    ViewParams::num_rows => 2,
                    ViewParams::paint_icon_selection_box => true,
                    ViewParams::paint_sandwich => true,
                    ViewItemParams::item_paint_caption => false,
                    ViewParams::sandwich_width => 200,
                    ViewParams::sandwich_height => 300,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => true,
                ),
                PluginRegularFolderView::base_view_item_params => array
                    (
                    ViewItemParams::item_paint_icon => false,
                    ViewItemParams::item_paint_caption => false,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_width => 200,
                    ViewItemParams::icon_height => 300,
                    ViewItemParams::icon_sel_margin_top => 0,
                    ViewItemParams::icon_sel_scale_factor => 1.2,
                ),
                PluginRegularFolderView::not_loaded_view_item_params => array
                    (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::icon_width => 300,
                    ViewItemParams::icon_height => 200,
                    ViewItemParams::icon_keep_aspect_ratio => true,
                    ViewItemParams::icon_sel_margin_top => 0
                ),
                PluginRegularFolderView::actions => $actions
            )
        );
    }

    /**
     *
     * @param type $items
     * @param type $actions
     * @return type 
     */
    static function build_text_list($items, $actions)
    {
        return array(
            PluginFolderView::view_kind => PLUGIN_FOLDER_VIEW_REGULAR,
            PluginFolderView::multiple_views_supported => false,
            PluginFolderView::data => array
                (
                PluginRegularFolderView::async_icon_loading => false,
                PluginRegularFolderView::initial_range => $items,
                PluginRegularFolderView::view_params => array
                    (
                    ViewParams::num_cols => 1,
                    ViewParams::num_rows => 12
                ),
                PluginRegularFolderView::base_view_item_params =>
                array
                    (
                    ViewItemParams::icon_path => 'missing://',
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_dx => 20,
                    ViewItemParams::icon_dy => -5,
                    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                    ViewItemParams::item_caption_width => 1550
                ),
                PluginRegularFolderView::not_loaded_view_item_params => array(),
                PluginRegularFolderView::actions => $actions
            )
        );
    }

    /**
     *
     * @param type $owner
     * @return type 
     */
    public static function get_dpkg_map(&$owner)
    {
//        $install_action = UserInputHandlerRegistry::create_action(
//                        $owner, 'Welcome->install');
//        $install_action['caption'] = (
//                "Установить"
//                );
//        
//        $remove_action = UserInputHandlerRegistry::create_action(
//                        $owner, 'Welcome->remove');
//        $remove_action['caption'] = (
//                "Удалить"
//                );
        
        $commit_action = UserInputHandlerRegistry::create_action(
                        $owner, 'Welcome->submit_operations');
        $commit_action['caption'] = (
                "Выполнить операции"
                );
        $settings_action = UserInputHandlerRegistry::create_action(
                        $owner, 'Setup->settings');
        $settings_action['caption'] = (
                "Настройки"
                );

        $info_action = UserInputHandlerRegistry::create_action(
                        $owner, 'Welcome->indicating');
        
        
        $revers_action = UserInputHandlerRegistry::create_action(
                        $owner, 'Welcome->revers');
        $revers_action['caption'] = (
                "Операции"
                );
        
//        $menu_items[] = array(
//            GuiMenuItemDef::caption => $install_action['caption'],
//            GuiMenuItemDef::action => $install_action
//        );
//        $menu_items[] = array(
//            GuiMenuItemDef::caption => $remove_action['caption'],
//            GuiMenuItemDef::action => $remove_action
//        );
        $menu_items[] = array(
            GuiMenuItemDef::caption => $commit_action['caption'],
            GuiMenuItemDef::action => $commit_action
        );
        $menu_items[] = array(
            GuiMenuItemDef::caption => $settings_action['caption'],
            GuiMenuItemDef::action => $settings_action
        );
        
        $popup_search_action = ActionFactory::show_popup_menu($menu_items);

        return array
            (
            GUI_EVENT_KEY_ENTER => $revers_action,
            GUI_EVENT_KEY_POPUP_MENU => $popup_search_action,  
//            GUI_EVENT_KEY_B_GREEN => $install_action,
//            GUI_EVENT_KEY_C_YELLOW => $remove_action,
            GUI_EVENT_KEY_D_BLUE => $commit_action,
            GUI_EVENT_KEY_INFO => $info_action,
        );
    }

    /**
     *
     * @param type $owner
     * @return type 
     */
    public static function get_templates_action_map(&$owner)
    {
        $remove_search_action = UserInputHandlerRegistry::create_action(
                        $owner, 'remove_template');
        $remove_search_action['caption'] = (
                "Удалить шаблон"
                );
        $menu_items[] = array(
            GuiMenuItemDef::caption => $remove_search_action['caption'],
            GuiMenuItemDef::action => $remove_search_action
        );
        $popup_search_action = ActionFactory::show_popup_menu($menu_items);


        return array
            (
            GUI_EVENT_KEY_ENTER => array
                (
                GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
            ),
            GUI_EVENT_KEY_POPUP_MENU => $popup_search_action,
            GUI_EVENT_KEY_B_GREEN => $remove_search_action
        );
    }

}

?>
