<?php

class TangoDunePlugin extends DefaultDunePlugin
{
    const UP_URL = 'http://dune-club.info/firmware/configuration.xml';
    const PLUGIN_NAME = 'dpm';
    const CURRENT_PLUGIN_VERSION = 20;
    const CURRENT_PLUGIN_VERSION_TITLE = 'v.2.1.2'; // Нельзя менять кавычки на двойные и количество пробелов. Важно для загружчика пакетов.
    const CURRENT_PLUGIN_VERSION_DATE = '26.09.12 16:49';  // Нельзя менять кавычки на двойные и количество пробелов. Важно для загружчика пакетов.
    const CURRENT_BIN_VERSION = 4;
    const CURRENT_BIN_PATH = '/mnt/config/';
    const CURRENT_BIN_NAME = 'ufdp';
    const CURRENT_BIN_HASH = 'e85114e984d0f66f2e37be32c18c7aa8'; // Do not forget checking md5sum with assigned executing permissions, it will be correctly.
    const LD_LIBRARY_PATH = 'export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/tango3/firmware_ext/flashlite/lib/;';

    /**
     * 
     * @param type $url
     * @param type $type 
     */
    function check_site_version(&$version, &$message)
    {
        $version = array();
        $message = '';

        $curl = curl_init();

        curl_setopt($curl, CURLOPT_URL, self::UP_URL);
        curl_setopt($curl, CURLOPT_COOKIESESSION, TRUE);
        curl_setopt($curl, CURLOPT_COOKIEFILE, "cookiefile");
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 4);
        curl_setopt($curl, CURLOPT_ENCODING, 'gzip,deflate');
        curl_setopt($curl, CURLOPT_USERAGENT, 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/535.11 (KHTML, like Gecko) Chrome/17.0.963.56 Safari/535.11');

        $content = curl_exec($curl);

        try
        {
            $plugins_settings = new SimpleXMLElement($content);
        } catch (Exception $e) {}

        if ($plugins_settings !== FALSE && count($plugins_settings) > 0)
        {
            foreach ($plugins_settings as $plugin)
            {
                if (isset($plugin->title) && $plugin->title == self::PLUGIN_NAME)
                {
                    if (isset($plugin->stabile->version_id) && $plugin->stabile->version_id > self::CURRENT_PLUGIN_VERSION)
                    {
                        $version['url'] = $plugin->stabile->url;
                        $version['level'] = $plugin->stabile->level;
                        $version['date'] = $plugin->stabile->date;
                        $version['name'] = $plugin->stabile->name;
                        $version['md5'] = $plugin->stabile->md5;

                        if ($version['level'] == 'critical') $message = 'Для правильной работы плагина, требуется обязательное обновление.';

                        return true;
                    }

                    if (isset($plugin->beta->version_id) && $plugin->beta->version_id > self::CURRENT_PLUGIN_VERSION)
                    {
                        $access_for_upgrade = Cookie::get('access_for_upgrade', 0);
                        if ($access_for_upgrade == 1)
                        {
                            // Download last beta versions
                            $version['url'] = $plugin->beta->url;
                            $version['level'] = $plugin->beta->level;
                            $version['date'] = $plugin->beta->date;
                            $version['name'] = $plugin->beta->name;
                            $version['md5'] = $plugin->beta->md5;

                            return true;
                        }
                    }
                }
            }
        }

        return false; // Site isn't available or it's other error.
    }

    /**
     * 
     */
    function copy_bin()
    {
        $cmd = 'cp ' . DOCROOT . self::CURRENT_BIN_NAME . ' ' . self::CURRENT_BIN_PATH;
        shell_exec($cmd);

        chmod(self::CURRENT_BIN_PATH . self::CURRENT_BIN_NAME, 0755);

        $cmd = 'chmod +x ' . self::CURRENT_BIN_PATH . self::CURRENT_BIN_NAME;
        shell_exec($cmd);
    }

    /**
     * 
     */
    function update_bin()
    {
        $cmd = 'rm -f ' . self::CURRENT_BIN_PATH . self::CURRENT_BIN_NAME;
        shell_exec($cmd);

        $cmd = 'cp ' . DOCROOT . self::CURRENT_BIN_NAME . ' ' . self::CURRENT_BIN_PATH;
        shell_exec($cmd);


        $cmd = 'chmod +x ' . self::CURRENT_BIN_PATH . self::CURRENT_BIN_NAME;
        shell_exec($cmd);
    }

    /**
     * 
     */
    function check_bin()
    {
        if (is_file(self::CURRENT_BIN_PATH . self::CURRENT_BIN_NAME) &&
                !is_file(DOCROOT . self::CURRENT_BIN_NAME))
        {
            hd_print('No new version of everything.');

            return true;
        }

        if (is_file(self::CURRENT_BIN_PATH . self::CURRENT_BIN_NAME))
        {
            $cmd = self::LD_LIBRARY_PATH . ' ' . self::CURRENT_BIN_PATH . self::CURRENT_BIN_NAME . ' -v'; // Get current version of bin file.
            $handle = popen($cmd, 'r');
            $read = fread($handle, 2096);
            $version = explode(':', $read);

            if (self::CURRENT_BIN_VERSION > trim($version[count($version) - 1]))
            {
                $this->update_bin();
            }
        } else
        {
            $this->copy_bin();
        }

        // Deleting bin file from distbution.
        $cmd = 'rm ' . DOCROOT . self::CURRENT_BIN_NAME;
        shell_exec($cmd);

        return is_file(self::CURRENT_BIN_PATH . self::CURRENT_BIN_NAME);
    }

    /**
     *
     * @param type $url
     * @param type $md5_sum 
     */
    static function start($url, $md5_sum)
    {
        $url = urldecode($url);
        $md5_sum = urldecode($md5_sum);

        if (!empty($url) && !empty($md5_sum))
        {
            $cmd = self::CURRENT_BIN_PATH . self::CURRENT_BIN_NAME;

            $handle = popen("md5sum $cmd", 'r');
            $recived_hash = fread($handle, 2096);
            pclose($handle);

            $recived_hash = explode(' ', $recived_hash);

            if (isset($recived_hash[0]) && trim($recived_hash[0]) === self::CURRENT_BIN_HASH)
            {
                $cmd = self::LD_LIBRARY_PATH . ' ' . self::CURRENT_BIN_PATH . self::CURRENT_BIN_NAME . ' ' . $url . ' ' . DOCROOT . '  ' . $md5_sum;
                shell_exec($cmd);
                hd_print($cmd);
            } else
            {
                hd_print('bad hash sum from bin file. md5:' . $recived_hash[0] . ' const md5:' . $md5_sum);
            }
        }

        hd_print('memory_get_usage = ' . memory_get_usage());

        // Show message.
        $defs = array();

        ControlFactory::add_label($defs, " ", 'Процесс обновления был запущен.');
        ControlFactory::add_label($defs, " ", 'Не выключайте приставку.');
        ControlFactory::add_label($defs, " ", 'Для проверки новой версии,');
        ControlFactory::add_label($defs, " ", 'перезапустите плагин через 3-5 сек.');

        ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'Welcome->index', 'Закрыть сообщение', 300, null);

        return ActionFactory::show_dialog('Обновления плагина...', $defs);
    }

    /**
     *
     * @param type $default_folder
     * @return type 
     */
    static function init($default_folder = 'Welcome->index')
    {
        $upgrader = new TangoDunePlugin();

        if ($upgrader->check_bin() &&
                $upgrader->check_site_version($version, $message))
        {
            hd_print('Aviable new version on the server - ' . json_encode($version));

            $handle = popen('pgrep ufdp', 'r');
            $installer_pid = fread($handle, 2096);

            $installer_pid = trim($installer_pid);

            if (empty($installer_pid))
            {
                $defs = array();

                ControlFactory::add_label($defs, " ", 'Доступна новая версия плагина: ' . $version['name'] . ' [' . $version['date'] . '].');
                ControlFactory::add_label($defs, " ", $message);

                $install_action = array
                    (
                    GuiAction::handler_string_id => PLUGIN_HANDLE_USER_INPUT_ACTION_ID,
                    GuiAction::data => array(
                        'media_url' => sprintf('Upgrader->start/%s/%s/', urlencode($version['url']), urlencode($version['md5']))
                    )
                );

                ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'Upgrader->start/' . urlencode($version['url']) . '/' . urlencode($version['md5']), 'Установить', 370, $install_action);

                if ($version['level'] != 'critical')
                {
                    $without_install_action = array
                        (
                        GuiAction::handler_string_id => PLUGIN_OPEN_FOLDER_ACTION_ID,
                        GuiAction::data => array(
                            'selected_media_url' => 'Welcome->index'
                        )
                    );

                    ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'Welcome->index', 'Не устанавливать', 370, $without_install_action);
                }

                return ActionFactory::show_dialog('Обновления:', $defs);
            } else
            {
                $defs = array();

                ControlFactory::add_label($defs, " ", 'Процесс всё ещё выполняется.');
                ControlFactory::add_label($defs, " ", 'Не выключайте приставку.');
                ControlFactory::add_label($defs, " ", 'Для проверки новой версии,');
                ControlFactory::add_label($defs, " ", 'перезапустите плагин через 3-5 сек.');

                ControlFactory::add_custom_close_dialog_and_apply_buffon($defs, 'Welcome->index', 'Закрыть сообщение', 300, null);

                return ActionFactory::show_dialog('Обновления плагина...', $defs);
            }
        }
    }

    /**
     * This metod recives calling from user's input.
     * @param type $input
     * @param type $plugin_cookies
     * @return type 
     */
    public function handle_user_input(&$input, &$plugin_cookies)
    {
        hd_print(sprintf('tango handle_user_input $input = %s', json_encode($input)));

        if (isset($input->selected_control_id))
        {
            preg_match_all('/(.\S*)\/(.\S*)\/(.\S*)/', $input->selected_control_id, $m_url);

            $media_url = isset($m_url[1][0]) ? $m_url[1][0] : $input->selected_control_id;
            $update_url = $m_url[2][0];
            $md5_hash = $m_url[3][0];
        } else
        {
            $media_url = $input->selected_media_url;
        }

        switch ($media_url)
        {
            case 'Welcome->start':

                return self::init();

            case 'Upgrader->start':

                return self::start($update_url, $md5_hash);

            case 'Welcome->reboot':

                return shell_exec('killall shell');
        }
    }

}

?>
