<?php

/**
 */
class Screen implements UserInputHandler
{
    const ID = 'Screen_ID';

    function handle_user_input(&$user_input, &$plugin_cookies) {}

    /**
     * 
     * @return type 
     */
    function get_handler_id()
    {
        return self::ID;
    }
    
    
    static public $screens = array();

    function __construct()
    {
        self::add($this);
    }

    static function add($object)
    {
        $obj = self::prepare($object);
        self::$screens[] = $obj;
        return $obj;
    }

    static function prepare($object)
    {
        return (object) array('handler' => $object);
    }

    static function explode($delimeter, $call)
    {
        $tmp = explode('->', $call);
        $name = $tmp[0];
        $method = 'index';
        $params = array();

        if (count($tmp) > 1)
        {
            $params = explode('/', $tmp[1]);
            if (count($params))
            {
                $method = $params[0];
                unset($params[0]);
            }
        }
        return array
            (
            'name' => $name,
            'method' => $method,
            'params' => $params
        );
    }

    static function find($call)
    {
        $classInfo = self::explode('->', $call);
        foreach (self::$screens as $i)
        {
            if (get_class($i->handler) == $classInfo['name'])
            {
                return array(
                    'object' => $i->handler,
                    'method' => $classInfo['method'],
                    'params' => $classInfo['params'],
                );
            }
        }
        return FALSE;
    }

    static function findOrCreate($call)
    {
        $screen = Screen::find($call);
        if ($screen === FALSE)
        {
            $classInfo = Screen::explode('->', $call);
            $className = $classInfo['name'];

            // Если ничего не нашли, пытаемся создавать новый объект вызываемого класса
            // 
            // Чтобы cоздаваевый класс попал в список screens, 
            // он должен быть наследован от класса Screen
            new $className();

            // Пытаемся еще раз найти объект
            $screen = Screen::find($call);
            if ($screen === FALSE)
            {
                exit("The class $className isn't extended of Screen");
            }
        }
        return $screen;
    }

    static function view($media_url)
    {
        if ($media_url == 'dummy')
            return array('');
        $screen = self::findOrCreate($media_url);
        $object = $screen['object'];
        $method = $screen['method'];
        $params = $screen['params'];
        
        return call_user_func_array(array($object, $method), $params);
    }

    static function viewRegular($media_url, $ndx)
    {
        if ($media_url == 'dummy')
            return array('');
        $screen = self::findOrCreate($media_url);
        $object = $screen['object'];
        $method = $screen['method'];
        $params = $screen['params'];
        $params = array_merge($params, array($ndx));
        return call_user_func_array(array($object, $method . 'Regular'), array($ndx));
    }

    static function call_input(&$arg)
    {
//        hd_print(json_encode($arg));
        if (isset($arg->selected_media_url))
        {
            if($arg->selected_media_url==='right_button')
            {
                $screen = self::findOrCreate($arg->parent_media_url);
            }     
            else
            {
                $screen = self::findOrCreate($arg->selected_media_url);
            }
        } 
        else
        {
            $control_id = $arg->control_id;
            if (isset($arg->$control_id))
                $screen = self::findOrCreate($control_id);
        }


        $object = $screen['object'];
        return $object->input($arg);
    }

    static function call_vodInfo($media_url)
    {
        if ($media_url == 'dummy')
            return array('');
        $screen = self::findOrCreate($media_url);
        $object = $screen['object'];
        $method = $screen['method'];
        $params = $screen['params'];
        return call_user_func_array(array($object, $method), $params);
    }

    /**
     *
     * @param type $node_id 
     */
    static function build_category($node = '')
    {
        hd_print('build_category node:'. $node);

        $var = Rise::$config->load($node);
        
        $items = array();
        if(count($var) > 0)
            foreach ($var as $k => $v)
            {
                $currnet_config = $node.'.'.$k;
                $current_action = Rise::$config->load($currnet_config.'.action');
                hd_print('$currnet_config node:'. $currnet_config);
                array_push($items, array
                    (
                    PluginRegularFolderItem::caption => Rise::$config->load($currnet_config.'.name'),
                    PluginRegularFolderItem::view_item_params => array(
                        ViewItemParams::item_paint_icon => FALSE,
                        ViewItemParams::item_layout => HALIGN_LEFT,
                        ViewItemParams::icon_valign => VALIGN_CENTER,
                        ViewItemParams::item_paint_caption_within_icon => false,
                        ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                    ),
                    PluginRegularFolderItem::media_url => !empty($current_action) ? $current_action.'/'.$currnet_config : 'NarkomSu_Category_Video->index/'.$currnet_config
                ));
            }
            
        return $items;
    }

    /**
     *
     * @param type $node
     * @return array
     */
    static function build_category_with_image($node = '')
    {
        hd_print('build_category node:'. $node);

        $var = Rise::$config->load($node);
        
        $items = array();
        if(count($var) > 0)
            foreach ($var as $k => $v)
            {
                $currnet_config = $node.'.'.$k;
                $current_action = Rise::$config->load($currnet_config.'.action');
                hd_print('$currnet_config node:'. $currnet_config);
                $icon = Rise::$config->load($currnet_config.'.icon');
                hd_print('$icon = '. $icon);
                array_push($items, array
                    (
                    PluginRegularFolderItem::caption => Rise::$config->load($currnet_config.'.name'),
                    PluginRegularFolderItem::view_item_params => array(
                        
                        ViewItemParams::icon_path => (!empty($icon) ? $icon : 'missing://'),
                        
                        ViewItemParams::item_layout => HALIGN_CENTER,
                        ViewItemParams::icon_valign => VALIGN_CENTER,
                        
                        ViewItemParams::icon_sel_scale_factor=>1.25,
                        ViewItemParams::icon_sel_margin_left => 30,
                        ViewItemParams::icon_sel_margin_top => 0,
                        ViewItemParams::icon_sel_margin_bottom => 4,
                        ViewItemParams::icon_margin_right => 0,
                        
                        ViewItemParams::item_paint_caption_within_icon => false,
                        ViewItemParams::item_paint_caption => false,
                        
                    ),
                    PluginRegularFolderItem::media_url => !empty($current_action) ? $current_action.'/'.$currnet_config : 'NarkomSu_Category_Video->index/'.$currnet_config
                ));
            }
            
        return $items;
    }
    
    /**
     *
     * @param type $a
     * @param type $b
     * @return string 
     */
    public static function encode_user_data($a, $b = null)
    {
        $media_url = null;
        $user_data = null;

        if (is_array($a) && is_null($b))
        {
            $media_url = '';
            $user_data = $a;
        }
        else
        {
            $media_url = $a;
            $user_data = $b;
        }

        if (!is_null($user_data))
            $media_url .= '||' . json_encode($user_data);

        return $media_url;
    }

    /**
     *
     * @param type $media_url_str
     * @param type $media_url
     * @param type $user_data
     * @return type 
     */
    public static function decode_user_data($media_url_str, &$media_url, &$user_data)
    {
        $idx = strpos($media_url_str, '||');

        if ($idx === false)
        {
            $media_url = $media_url_str;
            $user_data = null;
            return;
        }

        $media_url = substr($media_url_str, 0, $idx);
        $user_data = json_decode(substr($media_url_str, $idx + 2));
    }

}

?>
